# Copyright (c) Facebook, Inc. and its affiliates. All rights reserved.

#MODIFIED BY TORCHGPIPE
from contextlib import contextmanager
from typing import Any, Generator, Iterable, Union
from torch import ByteTensor, device

def set_rng_state(new_state: ByteTensor) -> None: ...
def get_rng_state() -> ByteTensor: ...

def manual_seed(seed: int) -> Any: ...
def seed() -> int: ...
def initial_seed() -> int: ...

@contextmanager
def fork_rng(devices: Iterable[Union[device, str, int]] = ..., enabled: bool = ...) -> Generator[None, None, None]: ...
#END
